;********************************************************************
;   TORNADO-E64cx Demo Utility.
;   Test for Bootload from FLASH with infinite McBSP-0 DX pin toggle. rev.1A
;   (C) MicroLAB Systems, 2002
;
;
;   Description:
;   ------------
;	This demo boots E64xx controller from FLASH/EPROM to DSP on-chip memory 
;	and afterthat continuously toggles McBSP-0 DX pin. 
;
;	Note, that initially booted code from ROM for C64xx cannot exceed 1kbytes,
;	so no C-code is allowed, which initially occupies more than 1KB.
;
;
;   TORNADO platform:
;   -----------------
;	TI CCS tools are required to recompile this demo and to
;	upload code to the on-board DSP environment.
;
;  Copyright:
;  ----------
;	This demo is distributed free of charge and as it is without
;	any obligation from MicroLAB Systems.
;
;
;  board configuration and demo parameters:
;  ----------------------------------------
;    on-board BOOT configuration switch SW2: FLASH8 BOOT mode
;
;***********************************************************************
	.text

; program starts from this '0' address
reset:
; keep McBSP-0 PCR register address in a10
	mvkl  .s1 0x18c0024,a10
	mvkh  .s1 0x18c0024,a10

; keep DX=0 data setting for McBSP-0 a0 reg
	mvkl  .s1 0x3f00,a0
	mvkh  .s1 0x3f00,a0

; keep DX=0 data setting for McBSP-0 a1
	mvkl  .s1 0x3f20,a1
	mvkh  .s1 0x3f20,a1

; now enter infinite loop
loop:
	stw   .d1  a0,*a10
	stw   .d1  a1,*a10
	b		loop
	nop 
	nop
	nop
	nop
	nop

