/****************************************************
  SBSRAM 128Kx64 memory test for E64xx f/w rev.1A boards.
  (C) MicroLAB Systems, 2002

  notes:
	1. E64xx boards are assumed to be configured
	   with no boot.
	2. Run E64XX_SBSRAM.C test demo for E64xx f/w rev.1A-1 and 
	   1A-2 boards.
*****************************************************/

#define	__TE6X_SDRAM128M__
#define	__TE6X_SELECT_E64XX__

#include "te6x_dsp.h"

unsigned *ptr ;

#define	DMEM_START_PTR	((unsigned *) TE64XX_SBSRAM_SADDR)
#define	DMEM_END_PTR	((unsigned *) (TE64XX_SBSRAM_SADDR+0xfffff))


unsigned start_data = 0xa596e73b,
         start_data_block;
unsigned mem_inc_data = 0x97b5f3be;
unsigned mem_wr_data;
unsigned pass_counter=0;


main()
{
   	TE6X_init_dsp_emif(0);

	while(1)
   	{
		start_data_block= start_data;

    	for(mem_wr_data=start_data, ptr=DMEM_START_PTR;
	      	ptr<=DMEM_END_PTR ; *ptr++ = mem_wr_data++);

        start_data += mem_inc_data ;

      	start_data=start_data_block;

        for(mem_wr_data=start_data, ptr=DMEM_START_PTR;
	      	ptr<=DMEM_END_PTR ;	)
   	   	{
        	if(*ptr++ != mem_wr_data++) goto error ;
	   	}
        start_data += mem_inc_data ;

     	pass_counter++;
    }

error:
	while(1) ;
}


