/****************************************************
  	TIMERs test for E64xx
	
  	This test uses TIMERs as I/O ports.
  	This test requires the TOUT jumper to be installed for 
	TIMERs #0..2, i.e. TINP pin is verified to be equal 
	to TOUT data. TM0 has longer '==0' duration.

   Note:
   ------
	This test does not run for E620x/E670x boards. 
	Use E6X_timers.* test instead.

*****************************************************/

#define	__TE6X_SDRAM128M__
#define	__TE6X_SELECT_E64XX__


#include "c6x_def.h"
#include "te6x_dsp.h"


#define TM_OUT_0  0
#define TM_OUT_1  4

unsigned pass_counter=0;

main()
{
	TE6X_init_dsp_emif(0);

   	*C6X_TM0_CONTROL=0;

   	while(1)
    {
		// test timer#0
		// set TOUT=0 
		*C6X_TM0_CONTROL = TM_OUT_0;
		// check for TINP==TOUT 
      	if((*C6X_TM0_CONTROL & 8) !=0) break; 
		// set TOUT=0 again for longer duration
      	*C6X_TM0_CONTROL = TM_OUT_0;
		// check for TINP==TOUT 
      	if((*C6X_TM0_CONTROL & 8) !=0) break; 
		// set TOUT=1 
      	*C6X_TM0_CONTROL = TM_OUT_1;
		// check for TINP==TOUT 
      	if((*C6X_TM0_CONTROL & 8) ==0) break; 


		// test timer#1
		// set TOUT=0 
      	*C6X_TM1_CONTROL = TM_OUT_0;
		// check for TINP==TOUT 
      	if((*C6X_TM1_CONTROL & 8) !=0) break; 
		// set TOUT=1 
      	*C6X_TM1_CONTROL = TM_OUT_1;
		// check for TINP==TOUT 
      	if((*C6X_TM1_CONTROL & 8) ==0) break; 


		// test timer#2
		// set TOUT=0 
      	*C6X_TM2_CONTROL = TM_OUT_0;
		// check for TINP==TOUT 
      	if((*C6X_TM2_CONTROL & 8) !=0) break; 
		// set TOUT=1 
      	*C6X_TM2_CONTROL = TM_OUT_1;
		// check for TINP==TOUT 
      	if((*C6X_TM2_CONTROL & 8) ==0) break; 


     	pass_counter++;
    }


  error:
    while(1) ;

}


