/****************************************************
  TIMERs test for E6x
	
  This test uses TIMER as I/O port.
  This test requires the TOUT jumper to be installed,
  i.e. TINP pin is verified to be equal to TOUT data.
  TM0 has longer '==0' duration.
*****************************************************/

#include "c6x_def.h"
#include "te6x_dsp.h"


#define TM_OUT_0  0
#define TM_OUT_1  4

unsigned pass_counter=0;

main()
{
	TE6X_init_dsp_emif(TE6X_XMEM_SBSRAM);

   *C6X_TM0_CONTROL=0;

   while(1)
    {
      /* verify for TINP==TOUT for TIMER-0 */
	/* set TOUT=0 */
      *C6X_TM0_CONTROL = TM_OUT_0;
	/* check for TINP==TOUT */
      if((*C6X_TM0_CONTROL & 8) !=0) break; 
      *C6X_TM0_CONTROL = TM_OUT_0;
	/* check for TINP==TOUT */
      if((*C6X_TM0_CONTROL & 8) !=0) break; 

	/* set TOUT=1 */
      *C6X_TM0_CONTROL = TM_OUT_1;
	/* check for TINP==TOUT */
      if((*C6X_TM0_CONTROL & 8) ==0) break; 


      /* verify for TINP==TOUT for TIMER-1 */
	/* set TOUT=0 */
      *C6X_TM1_CONTROL = TM_OUT_0;
	/* check for TINP==TOUT */
      if((*C6X_TM1_CONTROL & 8) !=0) break; 

	/* set TOUT=1 */
      *C6X_TM1_CONTROL = TM_OUT_1;
	/* check for TINP==TOUT */
      if((*C6X_TM1_CONTROL & 8) ==0) break; 


     pass_counter++;
    }


  error:
    while(1) ;

}


