/********************************************************************
   TORNADO-E6x Demo Utility. USART PIO Test. rev.1A
   (C) MicroLAB Systems, 2000


   Description:
   ------------
	This demo continuously generates 'running '1'' over 8-bit 
	USART parallel I/O port, which is available via JP10 on-board
	connector.


   TORNADO platform:
   -----------------
	This demo does not utilize any host TORNADO resources
	and runs in stand-alone mode. MIRAGE JTAG emulator and
	TI CCS tools are required to recompile this demo and to
	upload code to the on-board DSP environment.

  Copyright:
  ----------
	This demo is distributed free of charge and as it is without
	any obligation from MicroLAB Systems.


  board configuration and demo parameters:
  ----------------------------------------
        on-board bootmode configuration switch:
	  - MAP0/NOBOOT/SBSRAM
***********************************************************************/




#define	ML_OFF			0
#define	ML_ON			1

#include	<math.h>
#include 	"c6x_def.h"
#include 	"te6x_dsp.h"


void main()
{
	int i;

	// configure DSP EMIF to run with external SBSRAM
	TE6X_init_dsp_emif(TE6X_XMEM_SBSRAM);

	//configure USART I/O pins as outputs
	TE6X_set_usart_rg(TE_USART_PCR_RG,0);  

	while(1)
	 {
	   TE6X_wdt_reset();

	   TE6X_set_usart_rg(TE_USART_PVR_RG,0);
	   TE6X_set_usart_rg(TE_USART_PVR_RG,1);

	   for(i=1;i<8;i++)
	    {
	     TE6X_set_usart_rg(TE_USART_PVR_RG, 
						   TE6X_get_usart_rg(TE_USART_PVR_RG) << 1);
	    }
	 }
}
