/********************************************************************
   TORNADO-E64x Demo Utility.
   RTC (real-time clock) controller CLOCK OFF test. rev.1A
   (C) MicroLAB Systems, 2000


   Description:
   ------------
	This test sets RTC clock OFF in order to save backup battery energy.

   TORNADO platform:
   -----------------
	This demo does not utilize any host TORNADO resources
	and runs in stand-alone mode. MIRAGE JTAG emulator and
	TI CCS tools are required to recompile this demo and to
	upload code to the on-board DSP environment.

  Copyright:
  ----------
	This demo is distributed free of charge and as it is without
	any obligation from MicroLAB Systems.


  board configuration and demo parameters:
  ----------------------------------------
	- on-board BOOTMODE configuration switch: NOBOOT
***********************************************************************/

#define	__TE6X_SDRAM128M__
#define	__TE6X_SELECT_E64XX__

#include "c6x_def.h"
#include "te6x_dsp.h"


main()
{ 
	int i;


	// initialize DSP EMIF
   	TE6X_init_dsp_emif(0);

	// enable access to RTC controller
	TE6X_SET_RTC_ACCESS_ENABLE_ON;

	// clear TE bit of COMMAND register and freeze RTC clock registers
	TE6X_set_rtc_rg(TE_RTC_CMND_RG,0x00);


	// clear all RTC registers and disable clock via EOSC 
	// and ESQW bits of CLK MONTH register
	TE6X_set_rtc_rg(TE_RTC_CLK_SECONDS_FRACTION_RG,0x00);
	TE6X_set_rtc_rg(TE_RTC_CLK_SECONDS_RG,0x00);
	TE6X_set_rtc_rg(TE_RTC_CLK_MINUTES_RG,0x00);
	TE6X_set_rtc_rg(TE_RTC_CLK_HOURS_RG,0x00);
	TE6X_set_rtc_rg(TE_RTC_CLK_DAY_OF_WEEK_RG,0x00);
	TE6X_set_rtc_rg(TE_RTC_CLK_DATE_RG,0x00);
	TE6X_set_rtc_rg(TE_RTC_CLK_MONTH_RG,0xc0);	// disable clock oscillator
	TE6X_set_rtc_rg(TE_RTC_CLK_YEAR_RG,0x00);
	TE6X_set_rtc_rg(TE_RTC_ALARM_MINUTES_RG,0x00);
	TE6X_set_rtc_rg(TE_RTC_ALARM_HOURS_RG,0x00);
	TE6X_set_rtc_rg(TE_RTC_ALARM_DAY_OF_WEEK_RG,0x00);
	TE6X_set_rtc_rg(TE_RTC_WDT_SECONDS_FRACTION_RG,0x00);
	TE6X_set_rtc_rg(TE_RTC_WDT_SECONDS_RG,0x00);


	// set TE bit of COMMAND register and unfreeze RTC clock registers
	TE6X_set_rtc_rg(TE_RTC_CMND_RG,0x80);

	// clear NvRAM
	for(i=0;i<TE_RTC_USER_RAM_LEN;TE6X_set_rtc_user_ram(i++,0))

	// end here
	while(1);
}



