/********************************************************************
   TORNADO-E64x Demo Utility.
   RTC (real-time clock) controller USER RAM test. rev.1A
   (C) MicroLAB Systems, 2000


   Description:
   ------------
	This demo scans RTC data bus and RTC USER RAM registers.


   TORNADO platform:
   -----------------
	This demo does not utilize any host TORNADO resources
	and runs in stand-alone mode. MIRAGE JTAG emulator and
	TI CCS tools are required to recompile this demo and to
	upload code to the on-board DSP environment.

  Copyright:
  ----------
	This demo is distributed free of charge and as it is without
	any obligation from MicroLAB Systems.


  board configuration and demo parameters:
  ----------------------------------------
	- on-board BOOTMODE configuration switch: NOBOOT
***********************************************************************/

#define	__TE6X_SDRAM128M__
#define	__TE6X_SELECT_E64XX__

#include "c6x_def.h"
#include "te6x_dsp.h"



unsigned start_data = 0x3b,
         start_data_block;
unsigned mem_inc_data = 0x97;
unsigned mem_wr_data;
unsigned pass_counter=0;



main()
{ int i;
  unsigned short d;

	// init DSP EMIF
   TE6X_init_dsp_emif(0);


	// enable access to RTC controller
	TE6X_SET_RTC_ACCESS_ENABLE_ON;
	if(!TE6X_RTC_ACCESS_ENABLE_IS_ON)
	{
		// trap here on error at setting RTC access enable
		while(1);
	}

	//-- check RTC data bus via running 1<< to the USER_RAM #0 reg
	for(i=0,d=1;i<=8;i++)
	{
		TE6X_set_rtc_user_ram(0, i==0 ? 0:d);	
		TE6X_set_rtc_user_ram(1, 0xff);	// perform false bus data

		if(TE6X_get_rtc_user_ram(0) != (i==0 ? 0:d))
		{
			// trap here on error at the RTC data bus
			while(1);
		}

		if(i>0)	d <<= 1;
	}


	// continuously test RTC on-chip USER RAM registers
	while(1)
    {
      	start_data_block= start_data;
		for(mem_wr_data=start_data_block, i=0; i<TE_RTC_USER_RAM_LEN ;)
		{
			 TE6X_set_rtc_user_ram(i++,mem_wr_data++);
		}

		start_data=start_data_block;
		for(mem_wr_data=start_data, i=0; i<TE_RTC_USER_RAM_LEN ;)
 		{
            if(TE6X_get_rtc_user_ram(i++) != ((mem_wr_data++) & 0xff)) 
			{
				// trap here on error in the RTC USER RAM
				while(1);
			}
	   	}
		start_data += mem_inc_data ;
		start_data &= 0xff;

		pass_counter++;

    }
}



